//线程消息转发模块
//注意，worker是主线程创建worker后，系统注入的全局对象，可直接使用

import wasmapi from './wasmapi.js'

// if (console.log) {
//     var old = console.log
//     let self = this
//     console.log = function () {
//         worker.postMessage({ message: 'console', data: arguments }) //日志消息
//     }
// }
console.log("hello worker")

//线程监听服务程序
worker.onMessage((res) => {
    switch (res.message) {
        case 'MAIN_WORKER_LOAD_WX_WASM'://加载wxWasm模块
            wasmapi.loadWxWasm()
            break
        case 'MAIN_WORKER_BLE_BTS_DATA'://蓝牙基站数据
            wasmapi.saveBleBtsDataToLocal(res.data)
            break
        case 'MAIN_WORKER_CLEAR_BLE_BTS_DATA'://清除蓝牙基站数据
            wasmapi.clearBleBtsData(res.data)
            break
        case 'MAIN_WORKER_INSTALL_BTS_DATA'://安装基站数据
            wasmapi.sendInstallBtsDataToWasm(res.data)
            break
        case 'MAIN_WORKER_AUDIO_DATA'://音频采样数据
            wasmapi.processAudioData(res.data)
            break
        case 'MAIN_WORKER_FREE_MEMORY'://释放内存
            wasmapi.noticeWasmFreeMemory()
            break
        case 'MAIN_WORKER_SAVE_AUDIO_DATA'://保存录音文件
            worker.postMessage({
                message: 'WORKER_MAIN_SAVE_AUDIO_DATA',
                data: res.data//录音数据
            })
            break
        case 'MAIN_WORKER_ONE_ACC_DATA'://保存加速度
            wasmapi.storeAccData(res.data)
            break
        default:
            break
    }
})

